<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/application.sh ; app_load_status %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>
<html>
<body onload=window.parent.autoresize('fmt_iframe');>
<% 
SAP_PID=$(pidof ferdinand)

if [ "$FORM_format" != "" ] ; then
	echo "<div><pre>"
	echo "<p><font size=2>"
	fs=$(echo "$FORM_format" | awk -F, '{print $1;}')
	node=$(echo "$FORM_format" | awk -F, '{print $2;}')
	if [ "$(echo "$node" | grep -i mmc)" != "" ] ; then 
		MEDIA_TYPE="mmcsd"
	else
		MEDIA_TYPE="usb"
	fi
	fsckonly=$(echo "$FORM_format" | awk -F, '{print $3;}')
	MEDIA_DIR=$(cat /etc/ferdinand.conf | sed -n -e "s/^storage_media=//p")
	MNT_POINT=$(mount | grep -i "$node" | awk '{print $3;}')
	IN_USE=$(mount | grep -i $node | grep  "$MEDIA_DIR")
	SD_INUSE=$(echo "$IN_USE" | grep -i "mmcblk")
	LOCK_FILE="/tmp/.$(basename $MNT_POINT)"

	if [ "$fsckonly" != "" ] ; then
		fs=$(/sbin/blkid -s TYPE -o value $node)
		echo "Preparing to perform $fs file system check on $node<br>"
	else
		echo "Preparing to format $node to $fs<br>"
	fi
	
	if [ "$IN_USE" != "" ] ; then
		if [ "$SAP_PID" != "" ] ; then
			echo "The application is active, stopping it ...<br>"
			sudo /etc/init.d/application stop &> /dev/null
			SAP_NO_PID=$(pidof ferdinand)
			if [ "$SAP_NO_PID" != "$SAP_PID" ] ; then
				echo "Application successfully stopped !<br>"
			else
				echo "Could not stop the application, aborting format !<br>"
	                        echo "</pre></div>"                                     
	                        exit 0  
			fi
		fi
	else
		echo "The media is not in use, not stopping the application!<br>"
	fi
	
	if [ "$MNT_POINT" != "" ] ; then
		echo "Unmounting media ..."
		sudo /bin/umount $MNT_POINT &> /dev/null
		if [ mount | grep -Fq "$node" ] ; then
			echo "Could not unmount media, aborting format!<br>"
			echo "</pre></div>"
			exit 0
		else
			echo "Media successfully unmounted!<br>"
			echo "Removing media lock file $LOCK_FILE ..."
			rv=$(sudo /bin/rm $LOCK_FILE)
			[ -e "$LOCK_FILE" ] && echo "Deleting the lock file failed, you might need to replug the media or reboot the device!" || echo "Done!"
			echo "Removing the mount point ..."
			rv=$(sudo /bin/rm -rf $MNT_POINT)
			[ -e "$MNT_POINT" ] && echo "Deleting the mount point failed, you might need to replug the media or reboot the device!" || echo "Done!"
		fi
    else
        echo "Selected device not mounted, checking for orphaned LOCK files ...<br>"
        CHECK_LOCKS=`ls -1a /tmp | grep -i ".usbmst*\|.mmcsd*"` 
        for CURRENT_LOCK in $CHECK_LOCKS
        do
            echo "Checking LOCK file $CURRENT_LOCK ... "
            if [ "$(mount | grep -Fx "${CURRENT_LOCK:1}")" != "" ] ; then
                echo "OK!<br>"
            else
                echo "Not related to any mounted device, deleting it ...<br>"
                rv=$(sudo /bin/rm /tmp/$CURRENT_LOCK)
                [ -e "/tmp/$CURRENT_LOCK" ] && echo "Deleting the $CURRENT_LOCK failed, you might need to replug the media or reboot the device!" || echo "Done!"
            fi
        done
	fi
	
	if [ "$fsckonly" == "" ] ; then
		echo "Formatting media ... <br>"
	
		if [ "$fs" = "vfat" ] ; then
			sudo /sbin/mkfs.fat -F 32 -I -n BARIX "$node"
			OUT=$?
			if [ "$OUT" -eq 0 ] ; then 
				echo "Media successfully formated!"
			else
				echo "There were errors while formatting!"
			fi
		fi
	
		if [ "$fs" == "ext4" ] ; then 
			sudo /sbin/mkfs -t ext4 "$node"
			OUT=$?                                                          
			if [ "$OUT" -eq 0 ] ; then                                      
				echo "Media successfully formated!" 
				echo "Adjusting the file system check options ..."
				sudo /usr/sbin/tune2fs -c 1 -i 1m "$node"                 
			else                                                            
				echo "There were errors while formatting!"               
			fi  
		fi
	
	else
		echo "Checking media ... <br>"
		
		if [ "$fs" == "vfat" ] ; then
			FSCK_OPTS="-n"
			if [ "$fsckonly" == "err_fix" ] ; then
				FSCK_OPTS="-p"
			fi
			echo "Executing:"
			echo "fsck.fat $FSCK_OPTS $node"
			sudo /sbin/fsck.fat "$FSCK_OPTS" "$node"
			OUT=$?
			if [ "$OUT" -eq 0 ] ; then 
				echo "Media check finished!"
			else
				echo "There were errors while checking!"
			fi
		fi
	
		if [ "$fs" == "ext4" ] ; then 
			FSCK_OPTS="-nf"
			[ "$fsckonly" == "err_fix" ] && FSCK_OPTS="-p"
			echo "Executing:"
			echo "fsck.$fs $FSCK_OPTS $node"
			sudo /usr/sbin/fsck."$fs" "$FSCK_OPTS" "$node"
			OUT=$?                                                          
			if [ "$OUT" -eq 0 ] ; then                                      
				echo "Media check finished!" 
			else                                                            
				echo "There were errors while checking!"               
			fi
			# the -n option does not generate a plug event, so call the automount manually
			if [ "$fsckonly" == "no_err_fix" ] ; then
				echo "File system check run without the \"Fix Errors\" option, manually mounting it ..."
				sudo /lib/udev/automount add "$MEDIA_TYPE" "$node"
				OUT=$?                                                          
				if [ "$OUT" -eq 0 ] ; then                                      
					echo "Done!" 
				else                                                            
					echo "There were errors while mounting, you might need to replug the media or reboot the device!"               
				fi
			fi
		fi
	fi
	
	if [ "$SD_INUSE" != "" ] ; then
		echo "Restarting the application..."
		sleep 5
		sudo /etc/init.d/application restart &> /dev/null
		OUT=$?                                                          
        if [ "$OUT" -eq 0 ] ; then                                      
			echo "Application successfully started!"                     
		else                                                            
			echo "Could not start the application, please reboot the device!"              
		fi
	fi
	echo "</pre></div>"
fi	

%>
</body>
</html>
